'------------------------------------------------------------------------------
' 
'   ACTvZT[rX TvvO
'   INIt@CNX
'
'   Copyrights (c) 2004-2009 Advanced Core Technologies, Inc. All rights reserved.
'
'   2004/09/09 Rev.1.00 TAT ō쐬
'   2004/12/28 Rev.1.01 RIN C^[tFCX̏C
'
'------------------------------------------------------------------------------

'	Imported Namespace
Imports System.Runtime.InteropServices
Imports System.Text
Imports System.IO

'   Definition of Class
Public Class IniFile

    '------------------------------------------------------------------------------
    '	Win32 API
    '------------------------------------------------------------------------------

    '   [Private]

    '   ANSI GetPrivateProfileString
    Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" ( _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszSectionName As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszKeyName As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszDefault As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszReturnedString As StringBuilder, _
        ByVal nSize As Int32, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszFileName As String) As Int32
    '   ANSI GetPrivateProfileInt
    Private Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" ( _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszSectionName As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszKeyName As String, _
        ByVal nDefault As Int32, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszFileName As String) As Int32
    '   ANSI WritePrivateProfileString
    Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" ( _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszSectionName As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszKeyName As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszString As String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal lpszFileName As String) As Int32

    '------------------------------------------------------------------------------
    '	Constants
    '------------------------------------------------------------------------------

    '   [Private]

    Private Const DIRECTORY_SEPARATOR As String = "\"c              '   fBNgԂ̋؂L
    Private Const EXTENTION_SIGNATURE As String = "."c              '   gq̎ʕ
    Private Const EXTENTION_INIFILE As String = ".ini"              '   INIt@C̊gq
    Private Const BUFFER_LENGTH_MAX As Int32 = 260 + 1              '   obt@񒷂̍ől

    '------------------------------------------------------------------------------
    '	Members
    '------------------------------------------------------------------------------

    '   [Private]

    Private Shared m_AppPath As String                              '   AvP[VtH_pX
    Private Shared m_FileName As String                             '   INIt@C

    '------------------------------------------------------------------------------
    '	Methods
    '------------------------------------------------------------------------------

    '   [Public]

    '   LRXgN^
    Shared Sub New()
        Dim AppFileInfo As FileInfo         '   t@CNX
        Dim lpszFileNameBuffer As String    '   INIt@C쐬Ɏgpobt@
        Dim nExtentionIndex As Int32        '   gq INDEX l

        '   CX^X̍쐬
        AppFileInfo = New FileInfo(System.Reflection.Assembly.GetExecutingAssembly().Location)

        '   AvP[VtH_̃pXݒ肷
        m_AppPath = AppFileInfo.DirectoryName

        '   ftHgINIt@Cݒ肷
        lpszFileNameBuffer = AppFileInfo.FullName.Substring(m_AppPath.Length + 1)   '   st@C̎擾

        '   gq̒T
        nExtentionIndex = lpszFileNameBuffer.LastIndexOf(EXTENTION_SIGNATURE)
        '   gq݂͑邩H
        If nExtentionIndex <> -1 Then
            '   ݂̊gq̍폜
            lpszFileNameBuffer = lpszFileNameBuffer.Remove(nExtentionIndex, _
            lpszFileNameBuffer.Length - nExtentionIndex)
        End If
        '   INIt@Cݒ肷
        m_FileName = String.Concat(lpszFileNameBuffer, EXTENTION_INIFILE)           '   gq𖖔ɕt
    End Sub

    '   INIt@C̎w肵ZNṼL[當擾
    '   p[^
    '       lpszSectionName [IN]ZNV
    '       lpszKeyName     [IN]L[
    '       lpszDefault     [IN]INIt@C݂ȂꍇɕԂl
    '   ߂l
    '       w肵L[̕(Ggꍇ)
    '       lpszDefault         (GgȂꍇ)
    '       ̕          (lpszDefault  Nothing w肳Ăꍇ)
    Public Shared Function GetProfileString(ByVal lpszSectionName As String, ByVal lpszKeyName As String, ByVal lpszDefault As String) As String
        Dim lpszReturnedString As StringBuilder

        lpszReturnedString = New StringBuilder(BUFFER_LENGTH_MAX) '   CX^X̍쐬

        '   ftHglw肳Ă邩H
        If lpszDefault <> Nothing Then
            GetPrivateProfileString(lpszSectionName, lpszKeyName, lpszDefault, lpszReturnedString, _
            lpszReturnedString.Capacity, m_AppPath + DIRECTORY_SEPARATOR + m_FileName)
        Else
            GetPrivateProfileString(lpszSectionName, lpszKeyName, "", lpszReturnedString, _
            lpszReturnedString.Capacity, m_AppPath + DIRECTORY_SEPARATOR + m_FileName)
        End If

        Return lpszReturnedString.ToString()
    End Function

    '   INIt@C̎w肵ZNṼL[琔l擾
    '   p[^
    '       lpszSectionName [IN]ZNV
    '       lpszKeyName     [IN]L[
    '       lpszDefault     [IN]INIt@C݂ȂꍇɕԂl
    '   ߂l
    '       w肵L[̐l  (Ggꍇ)
    '       nDefault            (GgȂꍇ)
    '       0                   (GgɑΉlłȂꍇ)
    Public Shared Function GetProfileInt(ByVal lpszSectionName As String, ByVal lpszKeyName As String, ByVal nDefault As Int32) As Int32
        Return GetPrivateProfileInt(lpszSectionName, lpszKeyName, nDefault, _
        m_AppPath + DIRECTORY_SEPARATOR + m_FileName)
    End Function

    '   INIt@C̎w肵ZNṼL[ɕݒ肷
    '   p[^
    '       lpszSectionName [IN]ZNV
    '       lpszKeyName     [IN]L[
    '       lpszString      [IN]ݒ肷镶
    '   ߂l
    '       0ȊO   ̐ݒɐ
    '       0       ̐ݒɎs
    Public Shared Function WriteProfileString(ByVal lpszSectionName As String, ByVal lpszKeyName As String, ByVal lpszString As String) As Int32
        Return WritePrivateProfileString(lpszSectionName, lpszKeyName, lpszString, _
        m_AppPath + DIRECTORY_SEPARATOR + m_FileName)
    End Function

    '   INIt@C̎w肵ZNṼL[ɐlݒ肷
    '   p[^
    '       lpszSectionName [IN]ZNV
    '       lpszKeyName     [IN]L[
    '       nValue          [IN]ݒ肷鐔l
    '   ߂l
    '       0ȊO   l̐ݒɐ
    '       0       l̐ݒɎs
    Public Shared Function WriteProfileInt(ByVal lpszSectionName As String, ByVal lpszKeyName As String, ByVal nValue As Int32) As Int32
        Return WritePrivateProfileString(lpszSectionName, lpszKeyName, nValue.ToString(), _
        m_AppPath + DIRECTORY_SEPARATOR + m_FileName)
    End Function

    '   INIt@Cݒ(ύX)
    '   p[^
    '       lpszFileName [IN]INIt@C
    '   ߂l
    '       Ȃ
    Public Shared Sub SetFileName(ByVal lpszFileName As String)
        m_FileName = lpszFileName
    End Sub

End Class

'   End of Source
